import funkin.backend.utils.NativeAPI;
import lime.graphics.Image;

static var initialized:Bool = false;

function new() {
    // makes all of these options automatically set to their default values
    // gameplay options

    // visual options
    if (FlxG.save.data.flashingLights == null) FlxG.save.data.flashingLights = true;

    // other options
    if (FlxG.save.data.warningState == null) FlxG.save.data.warningState = true;

    if (!FlxG.save.data.flixelCursor) FlxG.mouse.useSystemCursor = true;
    else{
        FlxG.mouse.useSystemCursor = false;
        FlxG.mouse.load(Paths.image('cursor'));
    }

    window.title = "Impostor!Mania - V1 ( Sussy Mania release )";
    //window.setIcon(Image.fromBytes(Assets.getBytes(Paths.image('icon'))));
}

static var redirectStates:Map<FlxState, String> = [
    MainMenuState => "mania/ManiaMenuState",
    FreeplayState => "mania/ManiaFreeplayState",
];

function update(){
    if (FlxG.save.data.devMode)
        if (FlxG.keys.justPressed.F5)
            FlxG.resetState();
        if (FlxG.keys.justPressed.F6)
            NativeAPI.allocConsole();
}

function preStateSwitch() {
    FlxG.camera.bgColor = 0xFF000000;

	if (!initialized) {
		initialized = true;
		//FlxG.game._requestedState = new ModState('regen/WarningState');
	} else
		for (redirectState in redirectStates.keys())
			if (FlxG.game._requestedState is redirectState)
				FlxG.game._requestedState = new ModState(redirectStates.get(redirectState));
}

function onDestroy()
    FlxG.camera.bgColor = 0xFF000000;