import flixel.addons.display.FlxBackdrop;
import flixel.group.FlxTypedGroup;
import funkin.menus.ModSwitchMenu;
import funkin.editors.EditorPicker;
import flixel.text.FlxTextBorderStyle;
import flixel.math.FlxMath;
import funkin.menus.MainMenuState;
import funkin.menus.credits.CreditsMain;
import funkin.options.OptionsMenu;
import funkin.backend.scripting.Script;
import lime.app.Application;
import openfl.ui.Mouse;
import flixel.util.FlxAxes;

var codenameVersion = Application.current.meta.get('version');

var optionShit:Array<String> = ['Red','Green','Alibi','Black'];
var menuItems:FlxTypedGroup<FlxSprite> = new FlxTypedGroup();

var camZoom:FlxTween;

var confirm:FlxSound;
var cancel:FlxSound;
var hover:FlxSound;

var curSelected:Int = 0;

function create(){
	CoolUtil.playMenuSong();
	Script.staticVariables.set('skipTitleIntro', true);
	FlxG.mouse.visible = true;

	// loads sounds in for no lag when selecting something
	confirm = FlxG.sound.load(Paths.sound('menus/confirm'));
	cancel = FlxG.sound.load(Paths.sound('menus/cancel'));
	hover = FlxG.sound.load(Paths.sound('menus/hover'));

	tempBG = new FlxBackdrop(Paths.image('menus/main/background'));
	tempBG.scrollFactor.set(.1,.1);
	tempBG.antialiasing = Options.antialiasing;
	tempBG.velocity.set(20, 0);
	add(tempBG);

	topThing = new FlxBackdrop(Paths.image('menus/main/coolassthingUp'));
	topThing.scrollFactor.set(.1,.1);
	topThing.antialiasing = Options.antialiasing;
	topThing.velocity.set(50, 0);
	add(topThing);

	bottomThing = new FlxBackdrop(Paths.image('menus/main/coolassthingDown'));
	bottomThing.scrollFactor.set(.1,.1);
	bottomThing.antialiasing = Options.antialiasing;
	bottomThing.velocity.set(-50, 0);
	add(bottomThing);


	for(i in 0...optionShit.length){
		var menuItem:FunkinSprite = new FunkinSprite(355, 150);
		menuItem.frames = Paths.getSparrowAtlas('menus/freeplay/freeplayButtons');
		menuItem.animation.addByPrefix('idle', optionShit[i] + 'Button', 24, true);
		menuItem.animation.addByPrefix('hover', optionShit[i] + 'Select', 24, true);
		menuItem.ID = i;
		menuItems.add(menuItem);
        menuItem.scale.set(0.85, 0.85);
		menuItem.updateHitbox();
		menuItem.antialiasing = true;
		menuItem.screenCenter(FlxAxes.XY);

		switch(optionShit[i]){
			case "Red":
				menuItem.setPosition(105, 150);
			case "Green":
				menuItem.setPosition(405, 150);
			case "Alibi":
				menuItem.setPosition(705, 150);
			case "Black":
				menuItem.setPosition(1005, 150);
		}
	}

	add(menuItems);

	updateItems();
}

function selectItem(){
	var option = optionShit[curSelected];

		selectedSomethin = true;
		cursor = "arrow";
		confirm.play();
		
		FlxG.camera.zoom = 1;
		FlxTween.tween(FlxG.camera, {zoom: 4}, 4, {ease: FlxEase.expoOut});
		FlxTween.tween(FlxG.camera, {angle: 90}, 4, {ease: FlxEase.expoOut});
		FlxG.camera.fade(FlxColor.BLACK, 0.5, false);

		new FlxTimer().start(0.7, function(tmr:FlxTimer)
			{
				switchState();
			});
}

var selectedSomethin:Bool = false;
var cursor:String = null;
function update(elapsed){
	cursor = null;
	
	if (FlxG.sound.music.volume < 0.8) FlxG.sound.music.volume += 0.5 * elapsed;

    if (FlxG.keys.justPressed.SEVEN){
		persistentUpdate = !(persistentDraw = true);
		openSubState(new EditorPicker());
	}

	if (controls.SWITCHMOD) {
		openSubState(new ModSwitchMenu());
		persistentUpdate = !(persistentDraw = true);
	}

	if (controls.BACK || FlxG.mouse.justPressedRight){
		cancel.play();
	
		FlxTween.tween(FlxG.camera, {zoom: 1.2}, 2, {ease: FlxEase.expoOut});
		
		FlxG.camera.fade(FlxColor.BLACK, 0.5, false);
		new FlxTimer().start(.75, function(tmr:FlxTimer){
			FlxG.switchState(new ModState('mania/ManiaMenuState'));
		});
	}

	if (!selectedSomethin){
		for (i in menuItems.members){
			if (FlxG.mouse.overlaps(i)){
				cursor = "button";

				curSelected = menuItems.members.indexOf(i);
				//hover.play();
				updateItems();

				if (FlxG.mouse.justPressed)
					selectItem();
			}else
				i.animation.play("idle", true);
		}
	}

	Mouse.cursor = cursor ?? "arrow";
}

function updateItems() {
	menuItems.forEach(function(spr:FunkinSprite) {
		spr.animation.play('idle');
		if (spr.ID == curSelected) {
			spr.animation.play('hover');
		}
	});
}

function switchState() {
	var daChoice:String = optionShit[curSelected];

	switch (daChoice) {
		case 'Red':
			PlayState.loadSong("Sussy-Mania", "Hard", false, false);
			FlxG.switchState(new PlayState());
		case 'Green':
			FlxG.openURL('https://youtu.be/xrW31tZy848');
		case 'Alibi':
			FlxG.openURL('https://youtu.be/xrW31tZy848');
		case 'Black':
			FlxG.openURL('https://youtu.be/xrW31tZy848');

	}
}