import flixel.addons.display.FlxBackdrop;
import flixel.group.FlxTypedGroup;
import funkin.menus.ModSwitchMenu;
import funkin.editors.EditorPicker;
import flixel.text.FlxTextBorderStyle;
import flixel.math.FlxMath;
import funkin.menus.MainMenuState;
import funkin.menus.credits.CreditsMain;
import funkin.options.OptionsMenu;
import funkin.backend.scripting.Script;
import lime.app.Application;
import openfl.ui.Mouse;
import flixel.util.FlxAxes;
import flixel.tweens.FlxEase;
import flixel.tweens.FlxTween;

var codenameVersion = Application.current.meta.get('version');

var optionShit:Array<String> = ['Play', 'Options', 'Credits'];
var menuItems:FlxTypedGroup<FlxSprite> = new FlxTypedGroup();

var camZoom:FlxTween;

var confirm:FlxSound;
var cancel:FlxSound;
var shover:FlxSound;

var curSelected:Int = 0;

function create(){
	CoolUtil.playMenuSong();
	Script.staticVariables.set('skipTitleIntro', true);
	FlxG.mouse.visible = true;

	// loads sounds in for no lag when selecting something
	confirm = FlxG.sound.load(Paths.sound('menus/confirm'));
	cancel = FlxG.sound.load(Paths.sound('menus/cancel'));
	shover = FlxG.sound.load(Paths.sound('menus/hover'));


	tempBG = new FlxBackdrop(Paths.image('menus/main/background'));
	tempBG.scrollFactor.set(.1,.1);
	tempBG.antialiasing = Options.antialiasing;
	tempBG.velocity.set(20, 0);
	add(tempBG);

	topThing = new FlxBackdrop(Paths.image('menus/main/coolassthingUp'));
	topThing.scrollFactor.set(.1,.1);
	topThing.antialiasing = Options.antialiasing;
	topThing.velocity.set(50, 0);
	add(topThing);

	bottomThing = new FlxBackdrop(Paths.image('menus/main/coolassthingDown'));
	bottomThing.scrollFactor.set(.1,.1);
	bottomThing.antialiasing = Options.antialiasing;
	bottomThing.velocity.set(-50, 0);
	add(bottomThing);

	
	tabText = new FunkinText(525, 760, 0, 'Open the Mods Menu [TAB]');
	tabText.y -= tabText.height+50;
	add(tabText);

	versionShit = new FunkinText(515, 755, 0, 'Codename Engine - v.'+codenameVersion);
	versionShit.y -= versionShit.height+70;
	add(versionShit);


	tabText.screenCenter(FlxAxes.X);
	versionShit.screenCenter(FlxAxes.X);


	for(i in 0...optionShit.length){
		var menuItem:FunkinSprite = new FunkinSprite(355, 1000);
		menuItem.frames = Paths.getSparrowAtlas('menus/main/Buttonslol');
		menuItem.animation.addByPrefix('idle', optionShit[i] + 'Button', 24, true);
		menuItem.animation.addByPrefix('hover', optionShit[i] + 'Select', 24, true);
		menuItem.ID = i;
		menuItems.add(menuItem);
        menuItem.scale.set(0.85, 0.85);
		menuItem.antialiasing = true;

		switch(optionShit[i]){
			case "Play":
				menuItem.updateHitbox();
				menuItem.setPosition(435, 395);
			case "Options":
				menuItem.updateHitbox();
				menuItem.setPosition(200, 395);
			case "Credits":
				menuItem.updateHitbox();
				menuItem.setPosition(900, 395);
		}
	}

	add(menuItems);

	updateItems();
}

function selectItem(){
	var option = optionShit[curSelected];

		selectedSomethin = true;
		cursor = "arrow";
		confirm.play();
		
		FlxG.camera.zoom = 1;
		FlxTween.tween(FlxG.camera, {zoom: 4}, 4, {ease: FlxEase.expoOut});
		FlxTween.tween(FlxG.camera, {angle: 90}, 4, {ease: FlxEase.expoOut});
		FlxG.camera.fade(FlxColor.BLACK, 0.5, false);

		new FlxTimer().start(0.7, function(tmr:FlxTimer)
			{
				switchState();
			});
}

var selectedSomethin:Bool = false;
var cursor:String = null;
function update(elapsed){
	cursor = null;
	
	if (FlxG.sound.music.volume < 0.8) FlxG.sound.music.volume += 0.5 * elapsed;

    if (FlxG.keys.justPressed.SEVEN){
		persistentUpdate = !(persistentDraw = true);
		openSubState(new EditorPicker());
	}

	if (controls.SWITCHMOD) {
		openSubState(new ModSwitchMenu());
		persistentUpdate = !(persistentDraw = true);
	}

	if (controls.BACK || FlxG.mouse.justPressedRight){
		cancel.play();
	
		FlxTween.tween(FlxG.camera, {zoom: 1.2}, 2, {ease: FlxEase.expoOut});
		
		FlxG.camera.fade(FlxColor.BLACK, 0.5, false);
		new FlxTimer().start(.75, function(tmr:FlxTimer){
			FlxG.switchState(new TitleState());
		});
	}

	if (!selectedSomethin){
		for (i in menuItems.members){
			if (FlxG.mouse.overlaps(i)){
				cursor = "button";

				curSelected = menuItems.members.indexOf(i);
				//shover.play();
				updateItems();

				if (FlxG.mouse.justPressed)
					selectItem();
			}else
				i.animation.play("idle", true);
		}
	}

	Mouse.cursor = cursor ?? "arrow";
}

function updateItems() {
	menuItems.forEach(function(spr:FunkinSprite) {
		spr.animation.play('idle');
		if (spr.ID == curSelected) {
			spr.animation.play('hover');
		}
	});
}

function switchState() {
	var daChoice:String = optionShit[curSelected];

	switch (daChoice) {
		case 'Play':
			FlxG.switchState(new ModState('mania/ManiaFreeplayState'));
		case 'Options':
			FlxG.switchState(new OptionsMenu());
		case 'Credits':
			FlxG.switchState(new CreditsMain());
	}
}